#!/bin/sh
echo "####"
echo "##      advchk v3.00 :: reads security advisories, so you don't have to"
echo "#       Copyright (c) 2006-2009 Stephan Schmieder, http://unixgu.ru"

notFound () {
        echo "Can't find advchk in path and cwd!" 1>&2
        exit 1
}

export PATH="$PATH:/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:/opt/bin:/opt/sbin:/opt/local/bin:/opt/local/sbin:~/bin:.";
for i in http://feeds.sophos.com/en/rss2_0-sophos-latest-viruses.xml\
         http://newsroom.cisco.com/data/syndication/rss1/SecurityAdvisories_20.xml\
         http://uk.trendmicro-europe.com/enterprise/security_info/rssinfo.php\
         http://www.astalavista.com/feed/news_headlines_en.xml\
         http://www.cyberworlds.com/CSA.xml\
         http://www.debian.org/security/dsa-long\
         http://www.freebsd.org/security/advisories.rdf\
         http://www.linuxsecurity.com/static-content/linuxsecurity_advisories.rss\
         http://www.mcert.de/rss/mcert-rss.xml\
         http://www.microsoft.com/technet/security/advisory/RssFeed.aspx?securityadvisory\
         http://www.my-etrust.com/alertservice/pg.aspx?f=vul\
         http://www.net-security.org/dl/bck/advi.rss\
         http://www.net-security.org/dl/bck/vuln.rss\
         http://www.netbsd.org/Security/rss-advisories.xml\
         http://www.novell.com/newsfeeds/rss/securityPatches.xml\
         http://www.securiteam.com/securiteam.rss\
         http://www.securityfocus.com/rss/vulnerabilities.xml\
         http://www.us-cert.gov/channels/alerts.rdf\
         http://www.us-cert.gov/channels/techalerts.rdf\
         http://packetstormsecurity.org/advisories.xml\
         http://www.first.org/newsroom/globalsecurity/rss.xml\
         http://cert.belnet.be/rss.php\
         http://groups.google.de/group/django-announce/feed/rss_v2_0_msgs.xml?num=50\
         http://groups.google.com/group/rubyonrails-security/feed/rss_v2_0_msgs.xml?num=50\
         http://www.microsoft.com/technet/security/bulletin/secrss.aspx\
         http://www.nessus.org/rss-plugins.xml\
         http://www.webappsec.org/rss/websecurity.rss\
         http://CERT.Uni-Stuttgart.DE/ticker/rus-cert-elsewhere.rdf\
         http://groups.google.com/group/de.comp.security.misc/feed/rss_v2_0_topics.xml\
         http://cert.uni-stuttgart.de/ticker/rus-cert.rdf\
         http://www.vuxml.org/freebsd/rss.xml\
         http://www.vuxml.org/openbsd/rss.xml\
         http://www.openpkg.com/security/advisories/?format=rss\
         http://www.linux-community.de/Ticker/advisories.rdf\
         http://seclists.org/rss/bugtraq.rss\
         http://seclists.org/rss/fulldisclosure.rss\
         http://nvd.nist.gov/download/nvdcve-recent.xml\
         http://nvd.nist.gov/download/vendorstatements.xml\
         http://nvd.nist.gov/download/nvd-rss.xml\
         http://nvd.nist.gov/download/nvd-rss-analyzed.xml\
         http://www.ubuntu.com/taxonomy/term/2/0/feed\
         http://www.gentoo.org/rdf/en/glsa-index.rdf\
         http://www.novell.com/linux/security/suse_security.xml\
         http://secunia.com/information_partner/vulnerabilities.rss\
         http://www.xramp.com/securityalerts/rss.do; do
        advchk -a "$i" || notFound
done
