#!/bin/sh
####
##      advchk v3.00 :: reads security advisories, so you don't have to
#       Copyright (c) 2006-2009 Stephan Schmieder, http://unixgu.ru
#
#       This is the advchk installation script.
#       Quick Install for the brave:
#               chmod +x install.sh && sudo ./install.sh
#
PATH="$PATH:/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:/opt/bin:/opt/sbin:/opt/local/bin:/opt/local/sbin:~/bin:.";
export PATH;
ERRORS="";
export ERRORS;
(
        which perl >/dev/null || ( echo "
####
##      Installling Prerequisites
#       Perl
Press ENTER to continue, 's'+ENTER* to skip this step - or CTRL-C to abort setup." && ( read; echo "$REPLY" | grep 's' ) || (
                        apt-get install perl    || fink install perl    || port install perl
                );
                which perl >/dev/null || (
                        ERRORS="$ERRORS\nCan not install Perl. Advisory Check can NOT BE USED without Perl!";
                        echo            "Can not install Perl. Advisory Check can NOT BE USED without Perl!";
                );
        );
        for MODULE in Getopt::Std LWP::UserAgent Storable; do
                perl -e "use $MODULE" 2>/dev/null || ( echo "
####
##      Installling Prerequisites
#       $MODULE
Press ENTER to continue, 's'+ENTER* to skip this step - or CTRL-C to abort setup." && ( read; echo "$REPLY" | grep 's' ) || (
                                cpan -i $MODULE;
                                perl -e "use $MODULE" 2>/dev/null || (
                                        ERRORS="$ERRORS\nCan not install $MODULE. Advisory Check can NOT BE USED without $MODULE!":
                                        echo            "Can not install $MODULE. Advisory Check can NOT BE USED without $MODULE!";
                                );
                        );
                );
        done;
        echo "
####
##      Installing Advisory Check
#       to /usr/local
Press ENTER to continue, 's'+ENTER* to skip this step - or CTRL-C to abort setup." && ( read; echo "$REPLY" | grep 's' ) || (
        mkdir                           /usr/local/share 2>/dev/null && (
                chmod a+rx              /usr/local/share;
                chmod o-w               /usr/local/share;
        );
        mkdir                           /usr/local/share/man 2>/dev/null && (
                chmod a+rx              /usr/local/share/man;
                chmod o-w               /usr/local/share/man;
        );
        mkdir                           /usr/local/share/man/man1 2>/dev/null && (
                chmod a+rx              /usr/local/share/man/man1;
                chmod o-w               /usr/local/share/man/man1;
        );
        cp    man/advchk.1              /usr/local/share/man/man1/;
        chmod a+rx                      /usr/local/share/man/man1/advchk.1;
        chmod a-w                       /usr/local/share/man/man1/advchk.1;



        mkdir                           /usr/local/share/doc 2>/dev/null && (
                chmod a+rx              /usr/local/share/doc;
                chmod o-w               /usr/local/share/doc;
        );
        mkdir                           /usr/local/share/doc/advchk 2>/dev/null && (
                chmod a+rx              /usr/local/share/doc/advchk;
                chmod o-w               /usr/local/share/doc/advchk;
        );
        cp -r *                         /usr/local/share/doc/advchk/;
        chmod -R a+rx                   /usr/local/share/doc/advchk;
        chmod -R o-w                    /usr/local/share/doc/advchk;



        mkdir                           /usr/local/bin 2>/dev/null && (
                chmod a+rx              /usr/local/bin;
                chmod o-w               /usr/local/bin;
        );
        cp bin/advchk                   /usr/local/bin/;
        cp bin/advchk-addfeeds.sh       /usr/local/bin/;
        chmod a+rx                      /usr/local/bin/advchk;
        chmod a-w                       /usr/local/bin/advchk;
        chmod a+rx                      /usr/local/bin/advchk-addfeeds.sh;
        chmod a-w                       /usr/local/bin/advchk-addfeeds.sh;
                ERRORS="$ERRORS\nCan not install Advisory Check. Advisory Check can NOT BE USED!";
                echo            "Can not install Advisory Check. Advisory Check can NOT BE USED!";
        );

        which ssh >/dev/null || ( echo "
####
##      Installing Optional Components
#       OpenSSH client (remote login program)
Press ENTER to continue, 's'+ENTER* to skip this step - or CTRL-C to abort setup." && ( read; echo "$REPLY" | grep 's' ) || (
                        apt-get install openssh || fink install openssh || port install openssh
                );
                which ssh >/dev/null || (
                        ERRORS="$ERRORS\nCan not install OpenSSH. SSH Update will not be possible untill OpenSSH is installed!";
                        echo            "Can not install OpenSSH. SSH Update will not be possible untill OpenSSH is installed!";
                );
        );


        which nmap >/dev/null || ( echo "
####
##      Installling Optional Components
#       NMap (port scanner)
Press ENTER to continue, 's'+ENTER* to skip this step - or CTRL-C to abort setup." && ( read; echo "$REPLY" | grep 's' ) || (
                        apt-get install nmap    || fink install nmap    || port install nmap
                );
                which nmap >/dev/null || (
                        export ERRORS="$ERRORS\nCan not install NMap. NMap Update will not be possible untill NMap is installed!"
                        echo                   "Can not install NMap. NMap Update will not be possible untill NMap is installed!"
                );
        );

        which winexe >/dev/null || ( echo "
####
##      Installling Optional Components
#       WinExe (Windows RPC client)
Press ENTER to continue, 's'+ENTER* to skip this step - or CTRL-C to abort setup." && ( read; echo "$REPLY" | grep 's' ) || (
                        cd contrib/;
                        wget http://eol.ovh.org/winexe/winexe-source-081123.tar.bz2 || wget http://unixgu.ru/winexe-source-081123.tar.bz2;
                        bunzip2 winexe-source-081123.tar.bz2;
                        tar xf winexe-source-081123.tar;
                        cd winexe-source-081123/;
                        chmod +x autogen.sh
                        ./autogen.sh;
                        ./configure;
                        make proto bin/winexe
                        mkdir /usr/local/bin 2>/dev/null && (
                                chmod a+rx /usr/local/bin;
                                chmod o-w  /usr/local/bin;
                        );
                        cp bin/winexe /usr/local/bin/
                        chmod a+rx /usr/local/bin/winexe;
                        chmod o-w  /usr/local/bin/winexe;
                );
                which winexe >/dev/null || (
                        apt-get install winexe
                );
                which winexe >/dev/null || (
                        export ERRORS="$ERRORS\nCan not install WinExe. WIN Update will not be possible untill WinExe is installed!"
                        echo                   "Can not install WinExe. WIN Update will not be possible untill WinExe is installed!"
                );
        );

        echo "
####
##      Installing `grep  http bin/advchk-addfeeds.sh | wc -l | sed 's/\ //g'` Initial Feeds
#       to ~/.advchk/advchk.db
Press ENTER to continue, 's'+ENTER* to skip this step - or CTRL-C to abort setup." && ( read; echo "$REPLY" | grep 's' ) || (
                advchk-addfeeds.sh
        );

        echo "
####
##      Installing Environment variables
#       to ~/.profile
Press ENTER to continue, 's'+ENTER* to skip this step - or CTRL-C to abort setup." && ( read; echo "$REPLY" | grep 's' ) || (
                echo "export PATH='$PATH'"                      >> ~/.profile
                echo "export MANPATH='$MANPATH:/usr/local/man'" >> ~/.profile
        );

        echo " ";
        echo "$ERRORS" | grep Can >/dev/null || echo "Installation completed successfully.";
        echo "$ERRORS" | grep Can >/dev/null && echo "Installation completed with errors: $ERRPRS";
) 2>&1 | while read; do echo '['`date`"]  $REPLY"; done | tee -a install.log;
cp install.log /usr/local/share/doc/advchk/ 2>/dev/null >/dev/null;
echo " ";
echo "A protocol of this installation has been saved to install.log";
